import { store } from 'https://unpkg.com/@startinblox/core@0.9';
const sibAuth = document.querySelector('sib-auth');

//We create a custom element
class CoopStarterLoginComponent extends HTMLElement {
// Those function will be call the element is connected to the dom
  async connectedCallback() {
    document.getElementById("mentor_login").onclick = () => this.triggerLogin();
    this.update();
  }

  async triggerLogin() {
    let loader = document.getElementById('main-loader');
    loader.removeAttribute('hidden');
    await sibAuth.login();
  }
  
  async update() {
    let loader = document.getElementById('main-loader');
    loader.removeAttribute('hidden');
    let user = await sibAuth.getUser();
    // let idToken = await sibAuth.getUserIdToken();
    // console.log(window.location);
    
    // //Not connected and not sharing public resource
    // // console.log( user, sibAuth, window.location.href.indexOf('public-dashboard/public-resource-detail') === -1) 
    // if ( !user && window.location.href.indexOf('public-dashboard/public-resource-detail') === -1) {
    //   console.log("We have no user and not in public")
    //   loader.setAttribute("hidden", true);
    //   window.dispatchEvent(
    //     new CustomEvent('requestNavigation', { detail: { route: 'splash' } })
    //   );
    // }

    // //Not connected but sharing public resource
    // if(window.location.href.indexOf('public-dashboard/public-resource-detail') > -1) {
    //   console.log("We are targetting the public space !")
    //   //- window.dispatchEvent(
    //   //-   new CustomEvent('requestNavigation', { detail: { 
    //   //-     route: 'public-resource-detail'
    //   //-   } })
    //   //- );
    //   loader.setAttribute("hidden", true);
    //   return
    // }


    // Idenfify the space we should go
    user = await store.get(user);
    console.log("the curent user is ", user)

    //Set a userprefix default status
    var userPrefix = "public"

    //If the user is a mentor or an entreprenur, change user prefix
    if(user && user.mentor_profile) {
        userPrefix = "mentor"
        console.log("he is a ",userPrefix )
    } else if (user && user.entrepreneur_profile) {
        userPrefix = "entrepreneur"
        console.log("he is a ",userPrefix )
    }

    //If the url asked pointed to a resource
    if(window.location.href.indexOf('resource-detail') > -1) {
      console.log(" the link contains ressource detail")
      console.log("the current link is ", window.location.href)
      //We adapt the url with its status
      console.log("userPrefix", userPrefix)
      var newUrl = window.location.href.replace(/\/([a-z]+)-dashboard\/([a-z]+)-resource-detail/, `/${userPrefix}-dashboard/${userPrefix}-resource-detail`)
     // http://localhost:9000/fr/mentor-dashboard/@https~@~_~_api-staging~!coopstarter~!happy-dev~!fr~_resources~_7~_/mentor-resource-detail/@https~@~_~_api-staging~!coopstarter~!happy-dev~!fr~_resources~_7~_
      console.log("After treatement, the link is ", newUrl)

      //If the url is different after the treatment, we reload with the good url
      if(newUrl !== window.location.href){
        console.log("the url are ifférent, we relaod")
        
        var newRoute = new URL(newUrl).pathname.replace(/^\/([a-z]{2})\//, "")
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: newRoute } })
        );
        console.log("newRoute", newRoute)

        // window.location.href = newUrl

      }
      else{
        console.log("the url identique, let it go")
        loader.toggleAttribute('hidden', true);
      }
      

    } else {
      console.log("the current link doesn't concern a detail resource")
      if (user && user.mentor_profile) {
        //si y a un lien public alors on traite la chaine
        
        window.dispatchEvent(
            new CustomEvent('requestNavigation', { detail: { route: 'mentor-dashboard' } })
          );

      //User is a entrepreneur
      } else if (user && user.entrepreneur_profile) {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'entrepreneur-dashboard' } })
        );
      } else {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'account-creation' } })
        );
      }
    //user-dashboard
    }

    // //???
    // user = await store.get(user);
    // console.log(user)

    //User is a mentor
    
  }
  empty(){}
  populate(){}
}
// We can use <cs-login/>
customElements.define('cs-login', CoopStarterLoginComponent);